<script>
export default {
  name: 'StickyNav',
  props: {
    links: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      isSticky: false,
      activeLink: '',
    };
  },
  mounted() {
    window.addEventListener('scroll', this.handleScroll);
    this.updateActiveLink();
  },
  beforeDestroy() {
    window.removeEventListener('scroll', this.handleScroll);
  },
  methods: {
    handleScroll() {
      const navbar = this.$refs.navbar;
      if (navbar) {
        const sticky = navbar.offsetTop;
        this.isSticky = window.pageYOffset > sticky - 84; // 84px offset
      }
      this.updateActiveLink();
    },
    updateActiveLink() {
      const scrollPosition = window.scrollY + 84;

      this.links.forEach((link) => {
        const section = document.querySelector(link.href);
        if (section) {
          const sectionTop = section.offsetTop;
          const sectionHeight = section.offsetHeight;

          if (
            scrollPosition >= sectionTop &&
            scrollPosition < sectionTop + sectionHeight
          ) {
            this.activeLink = link.href;
          }
        }
      });
    },
  },
};
</script>

<template>
  <div>
    <nav ref="navbar" :class="{ sticky: isSticky }">
      <ul>
        <li
          v-for="link in links"
          :key="link.title"
          :class="{ active: activeLink === link.href }"
        >
          <a :href="link.href">{{ link.title }}</a>
        </li>
      </ul>
    </nav>
  </div>
</template>

<style lang="scss" scoped>
nav {
  background-color: $color-surface-700;
  padding: $spacing-16 0;
  transition: all 0.3s ease;
  z-index: 100;
}

nav ul {
  list-style: none;
  padding: 0;
  margin: 0;
  display: flex;
  justify-content: center;
  flex-wrap: wrap;

  @media (max-width: $breakpoint-sm) {
    flex-wrap: nowrap;
    justify-content: flex-start;
    overflow-x: scroll;
  }
}

nav li {
  margin: 0 $spacing-16;
}

nav li.active a {
  font-weight: 600;
  color: $color-accent-400;
  border-bottom: 1px solid $color-accent-400;
}

nav a {
  text-decoration: none;
  color: $color-text-50;

  &:hover {
    text-decoration: none;
    border-bottom: 1px solid $color-accent-400;
  }
}

.sticky {
  position: fixed;
  top: 84px;
  width: 100%;
  @media (max-width: $breakpoint-sm) {
    top: 116px;
  }
}
</style>
